package net.cattaka.rdbassistant.dummy;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;

import net.cattaka.rdbassistant.core.RdbaConnection;
import net.cattaka.rdbassistant.core.SqlEditorSelection;
import net.cattaka.rdbassistant.sql.Other;
import net.cattaka.swing.text.StdStyledDocument;

/**
 * 作成にはRdbConnectionFactoryを使用すること。
 * 
 * @author cattaka
 */
public class DummyRdbaConnection implements RdbaConnection {
	private DummySqlEditorSelection myEditorSelection;
	private String defaultDatabase;
	private Connection connection;
	
	DummyRdbaConnection(String defaultDatabase) {
		this.defaultDatabase = defaultDatabase.toUpperCase();
		myEditorSelection = new DummySqlEditorSelection(this);
		connection = new DummyConnection();
	}
	
	public Connection getConnection() {
		return this.connection;
	}

	public void dispose() {
		try {
			this.connection.close();
		} catch (SQLException e) {
			// あり得ない
		}
	}

	public String getDefaultDatabase() {
		return defaultDatabase;
	}

	public SqlEditorSelection getSqlEditorSelection() {
		return myEditorSelection;
	}

	public Class<?> getClassFromSqlType(int columnType) throws SQLException {
		return Other.class;
	}

	public Object extractResultSetData(ResultSet resultSet, Class<?> columnClass, int columnIndex) throws SQLException {
		return null;
	}

	public StdStyledDocument createNewSqlDocument() {
		DummyStyledDocument styledDocument = new DummyStyledDocument();
		return styledDocument;
	}
	
	public String getLastDbmsOutput() {
		return "";
	}
	
	public String getLineComment() {
		return "--";
	}
}
